
#include <gtkmm/window.h>
#include <gtkmm/main.h>
#include <gtkmm/box.h>
#include "dyncombo.h"


const char *aSheep[] = {"S1", "S2", "S3",};
const char *aAnts[]  = {"A1", "A2", "A3", "A4", "A5", "A6",};


//-----------------------------------------------------------------------------
// constructor
//
dyncombo::dyncombo()
    : m_butSheep("Sheep"),
      m_butAnt("Ant") {

    m_refTreeModelIndividuals = Gtk::ListStore::create(m_IndividualsColumns);
    m_cboIndividuals.set_model(m_refTreeModelIndividuals);

    m_butSheep.signal_clicked().connect(sigc::mem_fun(*this, &dyncombo::sheep_action) );
    m_butAnt.signal_clicked().connect(sigc::mem_fun(*this, &dyncombo::ant_action) );



    m_VBoxControl.pack_start(m_butSheep, Gtk::PACK_SHRINK);
    m_VBoxControl.pack_start(m_butAnt, Gtk::PACK_SHRINK);
    m_VBoxControl.pack_start(m_cboIndividuals, Gtk::PACK_SHRINK);

        
    resize(400, 400);
 
    // show the stuff
    add(m_VBoxControl);
    show_all_children();
 
}



//-----------------------------------------------------------------------------
// sheep_action
//
void dyncombo::sheep_action() {
    m_refTreeModelIndividuals->clear();
    for (int i = 0; i < sizeof(aSheep)/sizeof(char *); i++) {
        Gtk::TreeModel::Row row = *(m_refTreeModelIndividuals->append());
        row[m_IndividualsColumns.m_colName] = aSheep[i];
    }
    m_cboIndividuals.pack_start(m_IndividualsColumns.m_colName);
    m_cboIndividuals.set_active(0);  
}

//-----------------------------------------------------------------------------
// ant_action
//
void dyncombo::ant_action() {
    m_refTreeModelIndividuals->clear();
    for (int i = 0; i < sizeof(aAnts)/sizeof(char *); i++) {
        Gtk::TreeModel::Row row = *(m_refTreeModelIndividuals->append());
        row[m_IndividualsColumns.m_colName] = aAnts[i];
    }
    m_cboIndividuals.pack_start(m_IndividualsColumns.m_colName);
    m_cboIndividuals.set_active(0);  
}
